import cv2
import os
import glob
import numpy as np
from matplotlib import pyplot as plt
from joblib import Parallel, delayed
#from PIL import Image, ImageChops


in_dir = 'train_1/blue/'
out_dir = 'train_2/blue/'
JPEG_FILES = glob.glob( os.path.join(in_dir, '*.png'))


def convert(img_file):
	im = cv2.imread(img_file,0)
	kernel = np.ones((15,15),np.uint8)
	# kernel=cv2.getStructuringElement(cv2.MORPH_ELLIPSE,(14,14))
	# im = cv2.morphologyEx(im, cv2.MORPH_OPEN, kernel)
	# kernel=cv2.getStructuringElement(cv2.MORPH_CROSS,(12,12))
	dilation = cv2.dilate(im,kernel,iterations = 1)
	# im = cv2.morphologyEx(im, cv2.MORPH_OPEN, kernel)
	# kernel=cv2.getStructuringElement(cv2.MORPH_RECT,(2,2))
	# im = cv2.morphologyEx(im, cv2.MORPH_OPEN, kernel)
	# kernel=cv2.getStructuringElement(cv2.MORPH_ELLIPSE,(5,5))
	# im = cv2.morphologyEx(im, cv2.MORPH_OPEN, kernel)

	# kernel = np.ones((5,5),np.uint8)
	#img = cv2.medianBlur(im,0)
	#ret,th1 = cv2.threshold(img,127,255,cv2.THRESH_BINARY) 
	#th2 = cv2.adaptiveThreshold(img,255,cv2.ADAPTIVE_THRESH_MEAN_C,cv2.THRESH_BINARY,11,2) 
	#th3 = cv2.adaptiveThreshold(img,255,cv2.ADAPTIVE_THRESH_GAUSSIAN_C,cv2.THRESH_BINARY,11,2)
	cv2.imwrite(out_dir + os.path.splitext(os.path.basename(img_file))[0]+'.png',im)



Parallel(n_jobs=32, verbose=10)(delayed(convert)(f) for f in JPEG_FILES)














# import cv2
# import numpy as np

# img = cv2.imread('j.png',0)
# kernel = np.ones((5,5),np.uint8)
# erosion = cv2.erode(img,kernel,iterations = 1)